Unit MKComAbs;  {Abstract comm object unit}

{$I MKB.Def}

Interface
{
     MKComAbs - Copyright 1993 by Mark May - MK Software
     You are free to use this code in your programs, however
     it may not be included in Source/TPU function libraries
     without my permission.

     Mythical Kingom Tech BBS (513)237-7737 HST/v32
     FidoNet: 1:110/290
     Rime: ->MYTHKING
     You may also reach me at maym@dmapub.dma.org
}


Type AbsComObj = Object
  coBaud: LongInt;
  coPort: Byte;
  coFlow: Byte;
  coNumBits: Byte;
  coStopBits: Byte;
  coParity: Byte;
  Constructor Init;
  Destructor Done; Virtual;
  Function  OpenPort(PortNo: Byte; Baud: LongInt; Flow: Byte; NumBits: Byte;
    StopBits: Byte; Parity: Byte): Boolean; Virtual;
  Procedure ClosePort; Virtual;
  Procedure CommResume; Virtual;
  Function  GetCommPort: Integer;
  Procedure SetBPS(Rate: LongInt); Virtual;
  Function  GetBPS: LongInt; Virtual;
  Procedure LowerDTR; Virtual;
  Procedure RaiseDTR; Virtual;
  Function  GetInfo: String; Virtual;
  Function  OutReady: Boolean; Virtual;
  Function  OutEmpty: Boolean; Virtual;
  Function  InEmpty: Boolean; Virtual;
  Function  GetChar: Char; Virtual;
  Function  PeekChar: Char; Virtual;
  Procedure SendChar(Ch: Char); Virtual;
  Function  SendCharNW(Ch: Char): Boolean; Virtual;
  Procedure SetFlowCtl(FC: Byte); Virtual;
  Procedure StartBreak; Virtual;
  Procedure StopBreak; Virtual;
  Function  SendBlock(Var Dt; DSize: Word): Word; Virtual;
  Function  GetBlock(Var Dt; DSize: Word): Word; Virtual;
  Function  GetCarrier: Boolean; Virtual;
  Procedure FlushIn; Virtual;
  Procedure FlushOut; Virtual;
  Function  GetCommInfo: String; Virtual;
  End;


Type AbsComPtr = ^AbsComObj;


Const
  fcNone = 0;
  fcSoft = 1;
  fcHard = 2;
  fcBoth = fcSoft + fcHard;


Implementation


Constructor AbsComObj.Init;
  Begin
  coBaud := 2400;
  coPort := 1;
  coFlow := 0;
  coParity := 0;
  coNumBits := 8;
  coStopBits := 1;
  End;


Destructor AbsComObj.Done;
  Begin
  End;


Function AbsComObj.OpenPort(PortNo: Byte; Baud: LongInt; Flow: Byte; NumBits: Byte;
  StopBits: Byte; Parity: Byte): Boolean;
  Begin
  coPort := PortNo;
  coBaud := Baud;
  coFlow := Flow;
  coNumBits := NumBits;
  coStopBits := StopBits;
  coParity := Parity;
  End;


Function AbsComObj.GetCommPort: Integer;
  Begin
  GetCommPort := coPort;
  End;



Procedure AbsComObj.ClosePort;
  Begin
  End;


Procedure AbsComObj.CommResume;
  Begin
  If OpenPort(coPort, coBaud, coFlow, coNumBits, coStopBits, coParity) Then;
  End;


Procedure AbsComObj.SetBPS(Rate: LongInt);
  Begin
  coBaud := Rate;
  End;


Function AbsComObj.GetBPS: LongInt;
  Begin
  GetBPS := coBaud;
  End;


Procedure AbsComObj.LowerDTR;
  Begin
  End;


Procedure AbsComObj.RaiseDTR;
  Begin
  End;


Function AbsComObj.GetInfo: String;
  Begin
  GetInfo := 'Abstract';
  End;


Function AbsComObj.OutReady: Boolean;
  Begin
  OutReady := True;
  End;


Function AbsComObj.OutEmpty: Boolean;
  Begin
  OutEmpty := True;
  End;


Function AbsComObj.InEmpty: Boolean;
  Begin
  InEmpty := True;
  End;


Function AbsComObj.GetChar: Char;
  Begin
  GetChar := #0;
  End;


Function AbsComObj.PeekChar: Char;
  Begin
  PeekChar := #0;
  End;


Procedure AbsComObj.SendChar(Ch: Char);
  Begin
  End;


Function AbsComObj.SendCharNW(Ch: Char): Boolean;
  Begin
  SendCharNW := True;
  End;


Procedure AbsComObj.SetFlowCtl(FC: Byte);
  Begin
  End;


Procedure AbsComObj.StartBreak;
  Begin
  End;


Procedure AbsComObj.StopBreak;
  Begin
  End;


Function AbsComObj.SendBlock(Var Dt; DSize: Word): Word;
  Begin
  End;


Function AbsComObj.GetBlock(Var Dt; DSize: Word): Word;
  Begin
  End;


Function AbsComObj.GetCarrier: Boolean;
  Begin
  GetCarrier := True;
  End;


Procedure AbsComObj.FlushIn;
  Begin
  End;


Procedure AbsComObj.FlushOut;
  Begin
  End;


Function AbsComObj.GetCommInfo: String;
  Begin
  GetCommInfo := '';
  End;


End.
