Unit MKUsrMK;

{$I MKB.Def}

Interface

{
     MKUsrMK - Copyright 1993 by Mark May - MK Software
     You are free to use this code in your programs, however
     it may not be included in Source/TPU function libraries
     without my permission.

     Mythical Kingom Tech BBS (513)237-7737 HST/v32
     FidoNet: 1:110/290
     Rime: ->MYTHKING
     You may also reach me at maym@dmapub.dma.org
}


Uses MKGlobT, MKUsrAbs,
  {$IFDEF WINDOWS}
  WinDos;
  {$ELSE}
  Dos;
  {$ENDIF}

{$I Struct.MK}

Type MKUsrObj = Object(AbsUsrObj)
  ExitRec: ^ExitInfoType;
  Constructor Init; {Initialize}
  Destructor Done; Virtual; {Done}
  Function  UserFound: Boolean; Virtual; {Returns user found?}
  Function  GetChatReason: String; Virtual; {Get chat reason}
  Procedure SetChatReason(Reason: String); Virtual; {Set chat reason}
  Procedure ReadUser; Virtual; {Read user based on UserRecNum in ExitInfo}
  Procedure WriteUser; Virtual;
  Procedure AddUser; Virtual;
  Procedure AdjustTime(Adj: LongInt); Virtual;
  Procedure GetUserPos(Name: String); Virtual;
  Procedure ReadExit(EPath: String); Virtual; {Read ExitInfo from given path}
  Procedure WriteExit(EPath: String); Virtual; {Write ExitInfo to given path}
  Procedure AdjustUserTime(TA: LongInt); Virtual; {adjust user time remain by ta}
  Function  GetUserLineNum: Word; Virtual; {Get caller line number}
  Procedure SetUserLineNum(Ln: Word); Virtual; {Set caller line number}
  Procedure GetUserSec(Sec: Pointer); Virtual; {Get user security level/flags}
  Procedure SetUserSec(Sec: Pointer); Virtual; {Set user security level/flags}
  Function  GetUserSecLevel: LongInt; Virtual; {Get user security level}
  Function  GetUserSecStr: String; Virtual; {Get user security as string}
  Function  GetUserName: String; Virtual; {Get users name}
  Procedure SetUserName(NStr: String); Virtual; {Set users name}
  Function  GetUserCity: String; Virtual; {Get users city}
  Procedure SetUserCity(CStr: String); Virtual; {Set users city}
  Function  GetUserPwd: String; Virtual; {Get users password}
  Procedure SetUserPwd(PwdStr: String); Virtual; {Set users password}
  Function  GetUserDataPhone: String; Virtual; {Get users data phone}
  Procedure SetUserDataPhone(Phone: String); Virtual; {Set users data phone}
  Function  GetUserVoicePhone: String; Virtual; {Get users voice phone}
  Procedure SetUserVoicePhone(Voice: String); Virtual; {Set users voice phone}
  Function  GetUserCredit: LongInt; Virtual; {Get users netmail credit}
  Procedure SetUserCredit(Credit: LongInt); Virtual; {Set users netmail credit}
  Function  GetUserPending: LongInt; Virtual; {Get users pending netmail cost}
  Procedure SetUserPending(Pending: LongInt); Virtual; {Set users pending cost}
  Function  GetUserScrLength: Word; Virtual; {Get users screen length}
  Procedure SetUserScrLength(Scr: Word); Virtual; {Set users screen length}
  Function  GetUserMsgsEntered: LongInt; Virtual; {Get number of msgs entered}
  Procedure SetUserMsgsEntered(MsgE: LongInt); Virtual; {Set nbr of msgs entered}
  Function  GetUserTimesCalled: Word; Virtual; {Get number of times called}
  Procedure SetUserTimesCalled(Calls: Word); Virtual; {Set nbr of times called}
  Function  GetUserTodayBytes: LongInt; Virtual; {Get net transfers today}
  Procedure SetUserTodayBytes(TK: LongInt); Virtual; {Set net transfers today}
  Function  GetUserULBytes: LongInt; Virtual; {Get uploaded}
  Procedure SetUserULBytes(TK: LongInt); Virtual; {Set uploaded}
  Function  GetUserDLBytes: LongInt; Virtual; {Get downloaded}
  Procedure SetUserDLBytes(TK: LongInt); Virtual; {Set downloaded}
  Function  GetUserULFiles: LongInt; Virtual; {Get Num Files uploaded}
  Procedure SetUserULFiles (TK: LongInt); Virtual; {Set Num Files uploaded}
  Function  GetUserDLFiles: LongInt; Virtual; {Get Num Files downloaded}
  Procedure SetUserDLFiles (TK: LongInt); Virtual; {Set Num Files downloaded}
  Function  GetUserElapsed: Integer; Virtual; {Get Elapsed time prior calls today}
  Procedure SetUserElapsed (TK: Integer); Virtual; {Set Elapsed time}
  Procedure GetUserLastCall (Var LT: MKDateTime); Virtual;  {Get user last called time}
  Procedure SetUserLastCall (Var LT: MKDateTime); Virtual; {Set last called time}
  Procedure GetUserNewFileDate(Var DT: MKDateTime); Virtual; {Get user new file search date}
  Procedure SetUserNewFileDate(DT: MKDateTime); Virtual; {Set user new file search date}
  Function  GetUserGraphics: LongInt; Virtual; {Graphics capabilities}
  Procedure SetUserGraphics(UG: LongInt); Virtual; {Set graphics capabilities}
  Function  GetUserAvatar: Boolean; Virtual;   {Get avatar setting}
  Procedure SetUserAvatar(AV: Boolean); Virtual; {Set user avatar}
  Function  GetUserFullEd: Boolean; Virtual; {Get full-screen editor setting}
  Procedure SetUserFullEd(FE: Boolean); Virtual; {Set full-screen editor setting}
  Function  GetUserMore: Boolean; Virtual; {Get ask more setting}
  Procedure SetUserMore(Mo: Boolean); Virtual; {Set ask more setting}
  Function  GetUserScrnClr: Boolean; Virtual; {Get screen clear setting}
  Procedure SetUserScrnClr(Cl: Boolean); Virtual; {Set screen clear setting}
  Function  GetUserAnsi: Boolean; Virtual; {Get ansi setting}
  Procedure SetUserAnsi(UA: Boolean); Virtual; {Set user ansi}
  Function  GetUserLanguage: Byte; Virtual; {Get user lang number}
  Procedure SetUserLanguage(Ln: Byte); Virtual; {Set user lang number}
  Function  GetUserBaud: LongInt; Virtual; {Get user baud rate}
  Procedure SetUserBaud(Bd: LongInt); Virtual; {Set user baud rate}
  Function  GetUserMsgTemplate: Word; Virtual; {Get user msg template area}
  Procedure SetUserMsgTemplate(Tm: Word); Virtual; {Set user msg template area}
  Function  GetUserFileTemplate: Word; Virtual; {Get user file template area}
  Procedure SetUserFileTemplate(Tm: Word); Virtual; {Set user file template area}
  Function  GetUserDoorTemplate: Word; Virtual; {Get user door template area}
  Procedure SetUserDoorTemplate(Tm: Word); Virtual; {Set user door template area}
  Function  GetUserPageTimes: Word; Virtual; {Get number of times has paged}
  Procedure SetUserPageTimes(Pg: Word); Virtual; {Set number of times has paged}
  Function  GetUserTimeLimit: Integer; Virtual; {Get user time limit}
  Procedure SetUserTimeLimit(TL: Word); Virtual; {Set user time limit}
  Function  GetUserDLLimit: LongInt; Virtual; {Get user DL limit}
  Procedure SetUserDLLimit(DL: LongInt); Virtual; {Set user DL limit}
  Function  GetUserHandle: String; Virtual; {Get users handle}
  Procedure SetUserHandle(Hd: String); Virtual; {Set users handle}
  Function  GetUserPageTune: Byte; Virtual; {Get user page tune}
  Procedure SetUserPageTune(Tune: Byte); Virtual; {Set user page tune}
  Procedure GetUserBirthDate(Var BD: MKDateType); Virtual; {Get user birthdate MM-DD-YY}
  Procedure SetUserBirthDate(Var BD: MKDateType); Virtual; {Set user birthdate MM-DD-YY}
  Procedure GetUserFirstDate(Var FD: MKDateType); Virtual; {Get user first call MM-DD-YY}
  Procedure SetUserFirstDate(Var FD: MKDateType); Virtual; {Set user first call MM-DD-YY}
  Function  GetUserCombined(Area: Word): Boolean; Virtual; {Get user combined setting}
  Procedure SetUserCombined(Area: Word; St: Boolean); Virtual; {Set user combined}
  Procedure ClearGoSub; Virtual; {Clear gosub menu stack}
  Procedure GoSub(MN: String); Virtual; {Add MenuName MN to gosub stack}
  Function  GoSubReturn: String; Virtual; {Return MenuName from gosub stack}
  Function  GetUserRecNum: Word; Virtual; {Get user record number}
  Function  GetSessionTimeLimit: LongInt; Virtual; {Seconds this call allowed}
  Procedure SetSessionTimeLimit(TL: LongInt); Virtual; {Seconds allowed this call}
  Procedure SetStartTime; Virtual; {Set start time}
  Procedure UpdateForMsg; Virtual; {Increment msgs posted count}
  Procedure UpdateForDL(FSize: LongInt); Virtual; {Increment DL count and update K}
  Procedure UpdateForUL(FSize: LongInt); Virtual; {Increment UL count and update K}
  Function  UserIsLoaded: Boolean; Virtual;
  Procedure PostStatus(Status: Byte; SM: String); Virtual;
  Function  GetUserNumber: LongInt; Virtual;
  Function  GetUserProt: Char;  Virtual; {Get user default protocol}
  Procedure SetUserProt(PT: Char); Virtual; {Set user default protocol}
  Function  GetUserPacker: Char; Virtual;  {Get user default packer}
  Procedure SetUserPacker(PT: Char); Virtual; {Set user default packer}
  Function  FindUser(Name: String): LongInt; Virtual;
  End;


Type MKUsrObjPtr = ^MKUsrObj;

Implementation

Uses
  {$IFDEF WINDOWS}
  MKWCrt,
  {$ELSE}
    {$IFDEF OPRO}
    OpCrt,
    {$ELSE}
    Crt,
    {$ENDIF}
    MKScrn,
  {$ENDIF}
  MKString, MKFile, MKAvatar, MKCfgAbs, MKMisc, MKDos, MKFFile,
  {$IFDEF WINDOWS}
  MKComWin, Strings;
  {$ELSE}
  MKComDir, MKComFos, ExecAcc;
  {$ENDIF}


Function MKUsrObj.GetUserNumber: LongInt;
  Begin
  GetUserNumber := ExitRec^.UserRecNum;
  End;


Function MKUsrObj.GetChatReason: String;
  Begin
  GetChatReason := UserInfo^.ChatReason;
  End;


Procedure MKUsrObj.SetChatReason(Reason: String);
  Begin
  UserInfo^.ChatReason := Copy(Reason, 1, 50);
  End;


Procedure MKUsrObj.AdjustUserTime(TA: LongInt); {adjust user time remain by ta}
  Begin
  UserInfo^.TimeLimit := UserInfo^.TimeLimit + TA;
  End;


Constructor MKUsrObj.Init;
  Begin
  AbsUsrObj.Init;
  New(ExitRec);
  End;


Destructor MKUsrObj.Done;
  Begin
  Dispose(ExitRec);
  AbsUsrObj.Done;
  End;


Procedure MKUsrObj.ReadUser;
  Var
    UF: File;
    ErrorNum: Word;
    NumRead: Word;

  Begin
  If ExitRec^.UserRecNum >= 0 Then
    Begin
    Assign(UF, UserInfo^.UserFileName);
    FileMode := fmReadOnly + fmDenyNone;
    Reset(UF, SizeOf(UsersType));
    ErrorNum := IoResult;
    If ErrorNum = 0 Then
      Begin
      Seek(UF, ExitRec^.UserRecNum);
      ErrorNum := IoResult;
      End;
    If ErrorNum = 0 Then
      Begin
      If Not shRead(UF, ExitRec^.User, 1, NumRead) Then
        ErrorNum := MKFileError;
      End;
    End;
  End;


Procedure MKUsrObj.WriteUser;
  Var
    UF: File;
    ErrorNum: Word;

  Begin
  If ExitRec^.UserRecNum >= 0 Then
    Begin
    Assign(UF, UserInfo^.UserFileName);
    FileMode := fmReadWrite + fmDenyNone;
    If FileExist(UserInfo^.UserFileName) Then
      Reset(UF, SizeOf(UsersType))
    Else
      ReWrite(UF, Sizeof(UsersType));
    ErrorNum := IoResult;
    If ErrorNum = 0 Then
      Begin
      Seek(UF, ExitRec^.UserRecNum);
      ErrorNum := IoResult;
      End;
    If ErrorNum = 0 Then
      Begin
      If Not shWrite(UF, ExitRec^.User, 1) Then
        ErrorNum := MKFileError;
      End;
    End;
  End;


Procedure MKUsrObj.AddUser;
  Begin
  End;


Procedure MKUsrObj.GetUserPos(Name: String);
  Begin
  ExitRec^.UserRecNum := FindUser(Name);
  End;


Function MKUsrObj.UserFound: Boolean;          {Returns user found?}
  Begin
  UserFound := (ExitRec^.UserRecNum >= 0);
  End;


Procedure MKUsrObj.ReadExit(EPath: String);
  Begin
  If LoadFile(WithBackSlash(EPath) + 'ExitInfo.BBS', ExitRec^,
    SizeOf(ExitRec^)) = 0 Then;
  End;


Procedure MKUsrObj.WriteExit(EPath: String);
  Begin
  If SaveFile(WIthBackSlash(EPath) + 'ExitInfo.BBS', ExitRec^,
    SizeOf(ExitRec^)) = 0 Then;
  End;


Procedure MKUsrObj.GetUserSec(Sec: Pointer); {Get user security level/flags}
  Begin
  SecType(Sec^).Level := ExitRec^.User.Security;
  SecType(Sec^).Flags := ExitRec^.User.Flags;
  End;



Procedure MKUsrObj.SetUserSec(Sec: Pointer);
  Begin
  ExitRec^.User.Security := SecType(Sec^).Level;
  ExitRec^.User.Flags := SecType(Sec^).Flags;
  End;


Function MKUsrObj.GetUserSecLevel: LongInt;
  Begin
  GetUserSecLevel := ExitRec^.User.Security;
  End;


Function MKUsrObj.GetUserSecStr: String;
  Type ByteArray = Array[1..4] of Byte;

  Begin
  GetUserSecStr := PadLeft(Long2Str(ExitRec^.User.Security),' ',5) +
    Flag2Str(ByteArray(ExitRec^.User.Flags)[1]) + '  ' +
    Flag2Str(ByteArray(ExitRec^.User.Flags)[2]) + '  ' +
    Flag2Str(ByteArray(ExitRec^.User.Flags)[3]) + '  ' +
    Flag2Str(ByteArray(ExitRec^.User.Flags)[4]);
  End;


Function MKUsrObj.GetUserLineNum: Word;
  Begin
  GetUserLineNum := UserInfo^.LineNum;
  End;


Procedure MKUsrObj.SetUserLineNum(Ln: Word);
  Begin
  UserInfo^.LineNum := Ln;
  End;


Function MKUsrObj.GetUserName: String;       {Get users name}
  Begin
  GetUserName := ExitRec^.User.Name;
  End;


Procedure MKUsrObj.SetUserName(NStr: String); {Set users name}
  Begin
  ExitRec^.User.Name := NStr;
  End;


Function MKUsrObj.GetUserCity: String;       {Get users city}
  Begin
  GetUserCity := ExitRec^.User.City;
  End;


Procedure MKUsrObj.SetUserCity(CStr: String); {Set users city}
  Begin
  ExitRec^.User.City := CStr;
  End;


Function MKUsrObj.GetUserPwd: String;        {Get users password}
  Begin
  GetUserPwd := ExitRec^.User.Pwd;
  End;


Procedure MKUsrObj.SetUserPwd(PwdStr: String);{Set users password}
  Begin
  ExitRec^.User.Pwd := PwdStr;
  End;


Function MKUsrObj.GetUserDataPhone: String;  {Get users data phone}
  Begin
  GetUserDataPhone := ExitRec^.User.DPhone;
  End;


Procedure MKUsrObj.SetUserDataPhone(Phone: String); {Set users data phone}
  Begin
  ExitRec^.User.DPhone := Phone;
  End;


Function MKUsrObj.GetUserVoicePhone: String; {Get users voice phone}
  Begin
  GetUserVoicePhone := ExitRec^.User.HPhone;
  End;


Procedure MKUsrObj.SetUserVoicePhone(Voice: String); {Set users voice phone}
  Begin
  ExitRec^.User.HPhone := Voice;
  End;


Function MKUsrObj.GetUserCredit: LongInt;    {Get users netmail credit}
  Begin
  GetUserCredit := ExitRec^.User.Credit;
  End;


Procedure MKUsrObj.SetUserCredit(Credit: LongInt); {Set users netmail credit}
  Begin
  ExitRec^.User.Credit := Credit;
  End;


Function MKUsrObj.GetUserPending: LongInt;   {Get users pending netmail cost}
  Begin
  GetUserPending := ExitRec^.User.Pending;
  End;


Procedure MKUsrObj.SetUserPending(Pending: LongInt); {Set users pending cost}
  Begin
  ExitRec^.User.Pending := Pending;
  End;


Function MKUsrObj.GetUserScrLength: Word;    {Get users screen length}
  Begin
  GetUserScrLength := ExitRec^.User.ScrnLen;
  End;


Procedure MKUsrObj.SetUserScrLength(Scr: Word); {Set users screen length}
  Begin
  ExitRec^.User.ScrnLen := Scr;
  End;

Function MKUsrObj.GetUserMsgsEntered: LongInt;  {Get number of msgs entered}
  Begin
  GetUserMsgsEntered := ExitRec^.User.MsgsEntered;
  End;


Procedure MKUsrObj.SetUserMsgsEntered(MsgE: LongInt); {Set nbr of msgs entered}
  Begin
  ExitRec^.User.MsgsEntered := MsgE;
  End;


Function MKUsrObj.GetUserTimesCalled: Word;  {Get number of times called}
  Begin
  GetUserTimesCalled := ExitRec^.User.TimesCalled;
  End;


Procedure MKUsrObj.SetUserTimesCalled(Calls: Word); {Set nbr of times called}
  Begin
  ExitRec^.User.TimesCalled := Calls;
  End;


Function  MKUsrObj.GetUserTodayBytes: LongInt;
  Begin
  GetUserTodayBytes := LongInt(1024) * ExitRec^.User.TodayK;
  End;


Procedure MKUsrObj.SetUserTodayBytes(TK: LongInt);
  Begin
  ExitRec^.User.TodayK := TK Div LongInt(1024);
  End;


Function MKUsrObj.GetUserULBytes: LongInt;
  Begin
  GetUserULBytes := ExitRec^.User.ULK * LongInt(1024);
  End;


Procedure MKUsrObj.SetUserULBytes(TK: LongInt);
  Begin
  ExitRec^.User.ULK := TK Div LongInt(1024);
  End;


Function MKUsrObj.GetUserDLBytes: LongInt;
  Begin
  GetUserDLBytes := ExitRec^.User.DLK * LongInt(1024);
  End;


Procedure MKUsrObj.SetUserDLBytes (TK: LongInt);
  Begin
  ExitRec^.User.DLK := TK Div LongInt(1024);
  End;


Function  MKUsrObj.GetUserULFiles: LongInt;    {Get Num Files uploaded}
  Begin
  GetUserULFiles := ExitRec^.User.ULFiles;
  End;


Procedure MKUsrObj.SetUserULFiles (TK: LongInt); {Set Num Files uploaded today}
  Begin
  ExitRec^.User.ULFiles := TK;
  End;


Function MKUsrObj.GetUserDLFiles: LongInt;    {Get Num Files downloaded today}
  Begin
  GetUserDLFiles := ExitRec^.User.DLFiles;
  End;


Procedure MKUsrObj.SetUserDLFiles (TK: LongInt); {Set Num Files downloaded today}
  Begin
  ExitRec^.User.DLFiles := TK;
  End;


Function MKUsrObj.GetUserElapsed: Integer;    {Get Elapsed time prior calls today}
  Begin
  GetUserElapsed := ExitRec^.User.ElapsedTime;
  End;


Procedure MKUsrObj.SetUserElapsed (TK: Integer); {Set Elapsed time}
  Begin
  ExitRec^.User.ElapsedTime := TK;
  End;


Procedure MKUsrObj.GetUserLastCall(Var LT: MKDateTime);
  Var
    MKD: MKDateType;

  Begin
  Str2MKD(ExitRec^.User.LastDateOn, MKD);
  LT.Year := MKD.Year;
  LT.Month := MKD.Month;
  LT.Day := MKD.Day;
  Lt.Hour := Str2Long(Copy(ExitRec^.User.LastTimeOn,1,2));
  Lt.Min := Str2Long(Copy(ExitRec^.User.LastTimeOn,4,2));
  Lt.Sec := 0;
  End;


Procedure MKUsrObj.SetUserLastCall(Var LT: MKDateTime);
  Var
    MKD: MKDateType;

  Begin
  MKD.Year := LT.Year;
  MKD.Month := LT.Month;
  MKD.Day := Lt.Day;
  ExitRec^.User.LastDateOn := MKD2Str(MKD);
  ExitRec^.User.LastTimeOn := PadLeft(Long2Str(Lt.Hour),'0',2) + ':' +
    PadLeft(Long2Str(Lt.Min),'0',2);
  End;


Function MKUsrObj.GetUserLanguage: Byte;     {Get user lang number}
  Begin
  GetUserLanguage := ExitRec^.Language;
  End;


Procedure MKUsrObj.SetUserLanguage(Ln: Byte); {Set user lang number}
  Begin
  ExitRec^.Language := Ln;
  End;


Function MKUsrObj.GetUserBaud: LongInt;         {Get user baud rate}
  Begin
  GetUserBaud := ExitRec^.Baud;
  End;


Procedure MKUsrObj.SetUserBaud(Bd: LongInt);     {Set user baud rate}
  Begin
  ExitRec^.Baud := Bd;
  End;


Function MKUsrObj.GetUserMsgTemplate: Word; {Get user msg template area}
  Begin
  GetUserMsgTemplate := ExitRec^.ExtUser.CurrMsgArea;
  End;


Procedure MKUsrObj.SetUserMsgTemplate(Tm: Word); {Set user msg template area}
  Begin
  ExitRec^.ExtUser.CurrMsgArea := tm;
  End;


Function MKUsrObj.GetUserFileTemplate: Word; {Get user file template area}
  Begin
  GetUserFileTemplate := ExitRec^.ExtUser.CurrFileArea;
  End;


Procedure MKUsrObj.SetUserDoorTemplate(Tm: Word); {Set user door template area}
  Begin
  ExitRec^.ExtUser.CurrFileArea := tm;
  End;


Function MKUsrObj.GetUserDoorTemplate: Word; {Get user door template area}
  Begin
  GetUserDoorTemplate := ExitRec^.ExtUser.CurrDoorArea;
  End;


Procedure MKUsrObj.SetUserFileTemplate(Tm: Word); {Set user file template area}
  Begin
  ExitRec^.ExtUser.CurrDoorArea := tm;
  End;


Function  MKUsrObj.GetUserPageTimes: Word;    {Get number of times has paged}
  Begin
  GetUserPageTimes := ExitRec^.PagedTimes;
  End;


Procedure MKUsrObj.SetUserPageTimes(Pg: Word);{Set number of times has paged}
  Begin
  ExitRec^.PagedTimes := Pg;
  End;


Function  MKUsrObj.GetUserTimeLimit: Integer; {Get user time limit}
  Begin
  GetUserTimeLimit := ExitRec^.TimeLimit;
  End;


Procedure MKUsrObj.SetUserTimeLimit(TL: Word);{Set user time limit}
  Begin
  ExitRec^.TimeLimit := Tl;
  End;


Function  MKUsrObj.GetUserDLLimit: LongInt;      {Get user DL limit}
  Begin
  GetUserDLLimit := ExitRec^.DLLimit * LongInt(1024);
  End;


Procedure MKUsrObj.SetUserDLLimit(DL: LongInt);  {Set user DL limit}
   Begin
   ExitRec^.DLLimit := DL Div 1024;
   End;


Function MKUsrObj.GetUserCombined(Area: Word): Boolean;
  Begin
  GetUserCombined := ExitRec^.ExtUser.Combined[Area Div 8] and (Area Mod 8) <> 0;
  End;


Procedure MKUsrObj.SetUserCombined(Area: Word; St: Boolean);
  Begin
  If St Then
    ExitRec^.ExtUser.Combined[Area Div 8] := ExitRec^.ExtUser.Combined[Area Div 8]
    Or (Area Mod 8)
  Else
    ExitRec^.ExtUser.Combined[Area Div 8] := ExitRec^.ExtUser.Combined[Area Div 8]
    And (Not (Area Mod 8));
  End;


Function MKUsrObj.GetUserProt: Char;  {Get user default protocol}
  Begin
  GetUserProt := ExitRec^.ExtUser.Protocol;
  End;


Procedure MKUsrObj.SetUserProt(PT: Char); {Set user default protocol}
  Begin
  ExitRec^.ExtUser.Protocol := Pt;
  End;


Function MKUsrObj.GetUserPacker: Char;  {Get user default packer}
  Begin
  GetUserPacker := ExitRec^.ExtUser.Packer;
  End;


Procedure MKUsrObj.SetUserPacker(PT: Char); {Set user default packer}
  Begin
  ExitRec^.ExtUser.Packer := pt;
  End;


Function MKUsrObj.GetUserAvatar: Boolean;    {Get avatar setting}
  Begin
  GetUserAvatar := (ExitRec^.ExtUser.ExtraInfo and eiAvatar) <> 0;
  End;


Procedure MKUsrObj.SetUserAvatar(AV: Boolean);{Set user avatar}
  Begin
  If Av Then
    ExitRec^.ExtUser.ExtraInfo := ExitRec^.ExtUser.ExtraInfo or eiAvatar
  Else
    ExitRec^.ExtUser.ExtraInfo := ExitRec^.ExtUser.ExtraInfo and (Not eiAvatar);
  End;


Function MKUsrObj.GetUserHandle: String;
  Begin
  GetUserHandle := ExitRec^.ExtUser.Handle;
  End;


Procedure MKUsrObj.SetUserHandle(Hd: String);
  Begin
  ExitRec^.ExtUser.Handle := hd;
  End;


Procedure MKUsrObj.GetUserBirthDate(Var BD: MKDateType);
  Begin
  BD.Year := Str2Long(Copy(ExitRec^.ExtUser.BirthDate, 1, 2));
  BD.Month := Str2Long(Copy(ExitRec^.ExtUser.BirthDate, 3, 2));
  BD.Day := Str2Long(Copy(ExitRec^.ExtUser.BirthDate, 5, 2));
  If BD.Year < 20 Then
    Inc(BD.Year, 2000)
  Else
    Inc(BD.Year, 1900);
  End;


Procedure MKUsrObj.SetUserBirthDate(Var BD: MKDateType);
  Begin
  ExitRec^.ExtUser.BirthDate := PadLeft(Long2Str(BD.Year Mod 100),'0',2) +
    PadLeft(Long2Str(BD.Month),'0',2) + PadLeft(Long2Str(BD.Day),'0',2);
  End;


Procedure MKUsrObj.GetUserFirstDate(Var FD: MKDateType);
  Begin
  FD.Year := Str2Long(Copy(ExitRec^.ExtUser.FirstCall, 1, 2));
  FD.Month := Str2Long(Copy(ExitRec^.ExtUser.FirstCall, 3, 2));
  FD.Day := Str2Long(Copy(ExitRec^.ExtUser.FirstCall, 5, 2));
  If FD.Year < 80 Then
    Inc(FD.Year, 2000)
  Else
    Inc(FD.Year, 1900);
  End;


Procedure MKUsrObj.SetUserFirstDate(Var FD: MKDateType);
  Begin
  ExitRec^.ExtUser.FirstCall := PadLeft(Long2Str(FD.Year Mod 100),'0',2) +
    PadLeft(Long2Str(FD.Month),'0',2) + PadLeft(Long2Str(FD.Day),'0',2);
  End;


Function MKUsrObj.GetUserPageTune: Byte;
  Begin
  GetuserPageTune := ExitRec^.ExtUser.PageTune;
  End;


Procedure MKUsrObj.SetUserPageTune(Tune: Byte);
  Begin
  ExitRec^.ExtUser.PageTune := Tune;
  End;


Function MKUsrObj.GetUserAnsi: Boolean;      {Get ansi setting}
  Begin
  GetUserAnsi := (ExitRec^.User.Attr and uaAnsi) <> 0;
  End;


Procedure MKUsrObj.SetUserAnsi(UA: Boolean);  {Set user ansi}
  Begin
  If Ua Then
    ExitRec^.User.Attr := ExitRec^.User.Attr or (uaAnsi)
  Else
    ExitRec^.User.Attr := ExitRec^.User.Attr and (not uaAnsi);
  End;


Function MKUsrObj.GetUserFullEd: Boolean;    {Get full-screen editor setting}
  Begin
  GetUserFullEd := (ExitRec^.User.Attr and uaFullScrEd) <> 0;
  End;


Procedure MKUsrObj.SetUserFullEd(FE: Boolean);{Set full-screen editor setting}
  Begin
  If fe Then
    ExitRec^.User.Attr := ExitRec^.User.Attr or (uaFullScrEd)
  Else
    ExitRec^.User.Attr := ExitRec^.User.Attr and (not uaFullScrEd);
  End;


Function MKUsrObj.GetUserMore: Boolean;      {Get ask more setting}
  Begin
  GetUserMore := (ExitRec^.User.Attr and uaMore) <> 0;
  End;


Procedure MKUsrObj.SetUserMore(Mo: Boolean);  {Set ask more setting}
  Begin
  If Mo Then
    ExitRec^.User.Attr := ExitRec^.User.Attr or (uaMore)
  Else
    ExitRec^.User.Attr := ExitRec^.User.Attr and (not uaMore);
  End;


Function  MKUsrObj.GetUserScrnClr: Boolean;       {Get screen clear setting}
  Begin
  GetUserScrnClr := (ExitRec^.User.Attr and uaScrnClr) <> 0;
  End;


Procedure MKUsrObj.SetUserScrnClr(Cl: Boolean);   {Set screen clear setting}
  Begin
  If cl Then
    ExitRec^.User.Attr := ExitRec^.User.Attr or (uaScrnClr)
  Else
    ExitRec^.User.Attr := ExitRec^.User.Attr and (not uaScrnClr);
  End;


Procedure MKUsrObj.ClearGoSub;
  Begin
  ExitRec^.GoSubLevel := 0;
  End;


Procedure MKUsrObj.GoSub(MN: String);
  Begin
  If ExitRec^.GoSubLevel < 20 Then
    Begin
    Inc(ExitRec^.GoSubLevel);
    ExitRec^.GoSub[ExitRec^.GoSubLevel] := Mn;
    End;
  End;


Function MKUsrObj.GoSubReturn: String;
  Begin
  If ExitRec^.GoSubLevel > 0 Then
    Begin
    GoSubReturn := ExitRec^.GoSub[ExitRec^.GoSubLevel];
    Dec(ExitRec^.GoSubLevel);
    End
  Else
    GoSubReturn := '';
  End;


Function MKUsrObj.GetUserRecNum: Word;
  Begin
  GetUserRecNum := ExitRec^.UserRecNum;
  End;


Function MKUsrObj.GetSessionTimeLimit: LongInt; {Seconds this call allowed}
  Begin
  GetSessionTimeLimit := UserInfo^.TimeLimit;
  End;


Procedure MKUsrObj.SetSessionTimeLimit(TL: LongInt); {Seconds allowed this call}
  Begin
  ExitRec^.TimeLimit := TL;
  UserInfo^.TimeLimit := TL;
  End;


Procedure MKUsrObj.SetStartTime; {Set start time}
  Begin
  UserInfo^.StartDay := GetCurrentDay;
  UserInfo^.StartTime := CurrentTime;
  ExitRec^.LogInSec := CurrentTime;
  End;


Procedure MKUsrObj.UpdateForMsg; {Increment msgs posted count}
  Begin
  Inc(UserInfo^.MsgsToday);
  Inc(ExitRec^.User.MsgsEntered);
  End;


Procedure MKUsrObj.UpdateForDL(FSize: LongInt); {Increment DL count and update K}
  Begin
  Inc(UserInfo^.DLToday);
  Inc(ExitRec^.User.DLK, FSize Div 1024);
  Inc(ExitRec^.User.TodayK, FSize Div 1024);
  End;


Procedure MKUsrObj.UpdateForUL(FSize: LongInt); {Increment UL count and update K}
  Begin
  Inc(UserInfo^.ULToday);
  Inc(ExitRec^.User.ULK, FSize Div 1024);
  Dec(ExitRec^.User.TodayK, FSize Div 1024);
  End;


Function MKUsrObj.UserIsLoaded: Boolean;
  Begin
  UserIsLoaded :=  UserInfo^.UserLoaded;
  End;


Procedure MKUsrObj.PostStatus(Status: Byte; SM: String);
  Var
    UserOn: UserOnType;
    Tmp: LongInt;

  Begin
  If Status <> UserInfo^.LastStatus Then
    Begin
    FillChar(UserOn, SizeOf(UserOn), 0);
    UserOn.Status := Status;
    UserOn.Name := GetUserName;
    UserOn.Handle := GetUserHandle;
    UserOn.Node := GetUserLineNum;
    UserOn.City := GetUserCity;
    UserOn.Baud := GetUserBaud;
    Tmp := UserOn.Node;
    Tmp := Tmp * SizeOf(UserOnType);
    If ExtendFile(Config^.GetBbsPath + 'UserOn.BBS', Tmp) = 0 Then;
    If SaveFilePos(Config^.GetBBSPath + 'UserOn.BBS', UserOn,
      SizeOf(UserOn), Tmp - SizeOf(UserOnType)) = 0 Then
    UserInfo^.LastStatus := Status;
    End;
  End;


Procedure MKUsrObj.AdjustTime(Adj: LongInt);
  Begin
  UserInfo^.TimeLimit := UserInfo^.TimeLimit + Adj;
  End;


Procedure MKUsrObj.GetUserNewFileDate(Var DT: MKDateTime);
  Begin
  End;


Procedure MKUsrObj.SetUserNewFileDate(DT: MKDateTime);
  Begin
  End;


Function MKUsrObj.GetUserGraphics: LongInt;
  Var
    Tmp: LongInt;

  Begin
  Tmp := 0;
  If GetUserAnsi Then
    Inc(Tmp, 1);
  If GetUserAvatar Then
    Inc(Tmp, 2);
  GetUserGraphics := Tmp;
  End;


Procedure MKUsrObj.SetUserGraphics(UG: LongInt);
  Begin
  SetUserAnsi((UG and 1) <> 0);
  SetUserAvatar((UG and 2) <> 0);
  End;


Function MKUsrObj.FindUser(Name: String): LongInt;
  Var
    TUF: File;
    UFF: FFileObj;
    NumRead: Word;
    SName: String[35];
    NumUsers: LongInt;
    FUserNum: LongInt;
    WasFound: Boolean;
    UserRec: ^UsersType;

  Begin
  New(UserRec);
  If Not FileExist(UserInfo^.UserFileName) Then
    Begin
    If IoResult <> 0 Then;
    Assign(TUF, UserInfo^.UserFileName);
    ReWrite(TUF);
    Close(TUF);
    If IoResult <> 0 Then;
    End;
  FUserNum := 0;
  WasFound := False;
  UFF.Init(15000);
  If UFF.OpenFile(UserInfo^.UserFileName, fmReadOnly + fmDenyNone) Then
    Begin
    SName := Upper(Name);
    NumUsers := UFF.RawSize Div Sizeof(UsersType);
    While ((FUserNum <= NumUsers) and (Not WasFound)) Do
      Begin
      If UFF.SeekFile(FUserNum * SizeOf(UsersType)) Then
        If UFF.BlkRead(UserRec^, SizeOf(UsersType), NumRead) Then
          WasFound := (SName = Upper(UserRec^.Name));
      If Not WasFound Then
        Inc(FUserNum);
      End;
    End;
  UFF.Done;
  If Not WasFound Then
    FindUser := -1
  Else
    FindUser := FUserNum;
  If UFF.CloseFile Then;
  Dispose(UserRec);
  End;


End.
